-- Env_Laser by MikuAuahDark

Env_Laser={}	--{Turned on?,color,direction}

Env_Laser_IsScanned=false

function distance(x1,y1,x2,y2)
	return math.floor(math.sqrt((x1-x2)^2+(y1-y2)^2))
end

addhook("startround","Env_Laser_Scan")
function Env_Laser_Scan()
	Env_Laser_IsScanned=true
	for _, e in pairs(entitylist()) do
		if entity(e.x,e.y,"type")==93 then
			local n=entity(e.x,e.y,"trigger")
			local btype=entity(e.x,e.y,"int0")
			if n:find("Env_Laser")==1 and btype>=11 and btype<=15 then
				n=n:lower()
				local t=false
				if n:find("on")==11 then
					t=true
				end
				Env_Laser[e.x.."|"..e.y]={t,entity(e.x,e.y,"int0")-11,entity(e.x,e.y,"int1")}
			end
		end
	end
end
if Env_Laser_IsScanned==false then Env_Laser_Scan() end
			

addhook("triggerentity","Env_Laser_Toggle")
function Env_Laser_Toggle(x,y)
	local n=entity(x,y,"trigger")
	local btype=entity(x,y,"int0")
	if n:find("Env_Laser")==1 and btype>=11 and btype<=15 then
		local t=Env_Laser[x.."|"..y][1]
		Env_Laser[x.."|"..y][1]=not t
		return 1
	end
end

addhook("ms100","Env_Laser_Draw_Laser")
function Env_Laser_Draw_Laser()
	for n,v in pairs(Env_Laser) do
		if v[1]==true then
			local num=0
			while true do
				local r=180
				if v[3]==1 then r=0
				elseif v[3]==2 then r=90
				elseif v[3]==3 then r=270 end
				local a=math.rad(r+90)-math.pi
				local ex,ey=0,0
				for x,y in n:gmatch("(%d+)|(%d+)") do
					ex,ey=x*32+16,y*32+16
				end
				local x,y=ex+math.cos(a)*(num*4),ey+math.sin(a)*(num*4)
				if tile(math.floor(x/32),math.floor(y/32),"wall")==true then
					break
				end
				if x>0 and x<map("xsize")*32+32 and y>0 and y<map("ysize")*32+32 then
					local cstr="255 0 0"
					if v[2]==1 then cstr="0 255 0"
					elseif v[2]==2 then cstr="0 0 255"
					elseif v[2]==3 then cstr="255 255 0"
					elseif v[2]==4 then cstr="255 255 255" end
					parse("effect \"flare\" "..math.floor(x).." "..math.floor(y).." 1 1 "..cstr)
					for _, id in pairs(player(0,"table")) do
						if distance(x,y,player(id,"x"),player(id,"y"))<=24 and player(id,"health")>0 then
							parse("killplayer "..id)
						end
					end
				else
					break
				end
				num=num+1
			end
		end
	end
end